<?php

use App\Http\Controllers\Admin\ProductController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\PageController;
use Illuminate\Foundation\Application;
use Illuminate\Support\Facades\Route;
use Inertia\Inertia;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [PageController::class, 'Homepage'])->name('homepage');
Route::get('/aboutus', [PageController::class, 'AboutUs'])->name('aboutus');
Route::get('/ourproduct', [PageController::class, 'Ourproduct'])->name('ourproduct');
Route::get('/ourproductDetails', [PageController::class, 'ourProductDetails'])->name('ourproductdetails');
Route::get('/blogs', [PageController::class, 'Blog'])->name('blogs');
Route::get('/blogs/details', [PageController::class, 'blogsDetails'])->name('blogsdetails');
Route::get('/contact', [PageController::class, 'Contact'])->name('contact');
Route::get('/cart', [PageController::class, 'Cart'])->name('cart');
Route::get('/checkout', [PageController::class, 'Checkout'])->name('checkout');
Route::get('/confirmation', [PageController::class, 'Confirmation'])->name('confirmation');



Route::get('/dashboard', function () {
    return Inertia::render('Dashboard');
})->middleware(['auth', 'verified'])->name('dashboard');



Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');

    Route::resource('product', ProductController::class)->names('product');
});

require __DIR__.'/auth.php';
